/**
 * Created by yantianyu on 2014/12/12.
 */
var devJudge=(function(){
    var userAgent = window.navigator.userAgent.toLowerCase();
    return {
        isWeixin:function(){
            return userAgent.indexOf('micromessenger') > 0;
        },
        isAndroid:function(){
            return userAgent.indexOf('android') > 0;
        },
        isIOS:function(){
            return /iphone/i.test(userAgent) || /ipod/i.test(userAgent) || /ipad/i.test(userAgent);
        }
    }
})();

var JSNativeBridge = (function(){
    var _handler = null;
    function _send(id, content) {
        uplusInterface.postWebpageMessage(id, encodeURIComponent(JSON.stringify(!content ? '' : content)));
    }

    function _receive(msg, msg_content) {
        _handler(msg, msg_content);
    }

    function _addHandler(handler) {
        _handler = handler;
    }

    return {
        send: function(id, content) {
            _send(id, content);
        },

        receive: function(msg_id, msg_content) {
            try {
                _receive(msg_id, JSON.parse(decodeURIComponent(msg_content)));
            } catch(e) {

            }
        },
        postNativeMessage: function() {
            JSNativeBridge.receive.apply(this, arguments);
        },

        init: function(handler) {
            if(!window.uplusInterface) {
                uplusInterface = {};
                uplusInterface.postWebpageMessage = function(id, content) {
                    window.location.href += '#msg_id=' + id + '&msg_content=' + content;
                }
            }
            _addHandler(handler);
        }
    }
}());

var StyleModeChange={
    currentMode:"",
    nightMode:function(){
        console.log("nightMode");
        if(StyleModeChange.currentMode=="nightMode"){
            return;
        }
        $("img").each(function(index, elem){
            var img = new Image();
            img.onload = function() {

                if(img.width==0 || /android_asset\/images/.test($(elem).attr("src"))){
                    elem.src=$(elem).attr("src").replace("/day-mode/","/night-mode/");
                    return;
                }

                var canvas = document.createElement('canvas');
                $(canvas).insertAfter(elem);
                canvas.width = img.width;
                canvas.height = img.height;
                $(canvas).attr("style",$(elem).attr("style"));

                if(config.phaseId==PhaseType.MiddleSchool) {            //初中数学题对图片做了缩放,此处也需要对canvas做缩放
                    canvas.style.width=(img.width/2+4*img.width/img.height)+"px";
                    canvas.style.height=(img.height/2+4)+"px";
                }

                var ctx = canvas.getContext('2d');
                ctx.drawImage(img, 0, 0);
                var imgData = ctx.getImageData(0, 0, img.width, img.height);
                var data = imgData.data;
                function invert() {
                    for(var i = 0; i < data.length; i+=4) {
                        if(data[i+3] != 0) {
                            if(data[i] > 200) {
                                data[i] = 35;
                                data[i+1] = 35;
                                data[i+2] = 35;
                            }else{
//                                data[i] = (255 - data[i]) > 200 ? 176 : (255 - data[i]) ;
//                                data[i + 1] = (255 - data[i+1]) > 200 ? 176 : (255 - data[i+1]) ;
//                                data[i + 2] = (255 - data[i+2]) > 200 ? 176 : (255 - data[i+2]) ;
                                data[i] = 70 ;
                                data[i + 1] = 70 ;
                                data[i + 2] = 70 ;
                                if( data[i+3] != 255) {
                                    data[i+3] = 255;
                                }
                            }
                        }
                    }
                    ctx.putImageData(imgData, 0, 0);
                }
                invert();
                delete img;
                $(elem).hide();
            };
            img.src = elem.src;
        });

        $(".style_mode_css").each(function(){
            $(this)[0].href = $(this).attr("href").replace("day_mode","night_mode");
        });

        $(".j_math td").css("border-color","#b0b0b0");      //此样式不能被提至css文件中，会被行内样式覆盖
        StyleModeChange.currentMode="nightMode";
    },
    dayMode:function(){
        if(StyleModeChange.currentMode=="dayMode"){
            return;
        }
        $("img").each(function(){
            if(!$(this).next().is("canvas")){
                this.src=$(this).attr("src").replace("/night-mode/","/day-mode/");
                return;
            }
            $(this).show().next().remove();
        });

        $(".style_mode_css").each(function(){
            $(this)[0].href = $(this).attr("href").replace("night_mode","day_mode");
        });

        $(".j_math td").css("border-color","#000000");      //此样式不能被提至css文件中，会被行内样式覆盖
        StyleModeChange.currentMode="dayMode";
    }
};